/**
 * Autogenerated by Avro
 *
 * DO NOT EDIT DIRECTLY
 */
package com.marcofabbian.transaction.avroschema;

import org.apache.avro.generic.GenericArray;
import org.apache.avro.specific.SpecificData;
import org.apache.avro.util.Utf8;
import org.apache.avro.message.BinaryMessageEncoder;
import org.apache.avro.message.BinaryMessageDecoder;
import org.apache.avro.message.SchemaStore;

@org.apache.avro.specific.AvroGenerated
public class Transaction extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  private static final long serialVersionUID = -2697819791808145642L;


  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"Transaction\",\"namespace\":\"com.marcofabbian.transaction.avroschema\",\"fields\":[{\"name\":\"id\",\"type\":\"string\",\"doc\":\"Transaction unique identifier\"},{\"name\":\"messageCreation\",\"type\":\"long\",\"doc\":\"Transaction message creation datetime\"},{\"name\":\"price\",\"type\":{\"type\":\"string\",\"java-class\":\"java.math.BigDecimal\"},\"doc\":\"Transaction Price\"},{\"name\":\"currency\",\"type\":\"string\",\"doc\":\"Transaction currency\"},{\"name\":\"quantity\",\"type\":\"int\",\"doc\":\"Transaction quantity. Number of goods sold/bought\"},{\"name\":\"instrumentID\",\"type\":\"string\",\"doc\":\"ISIN code that represent the good\"},{\"name\":\"bookingDateTime\",\"type\":\"long\",\"doc\":\"Datetime of the booking\"},{\"name\":\"settlementDateTime\",\"type\":\"long\",\"doc\":\"Datetime of the settlement\"},{\"name\":\"bookingCenterID\",\"type\":\"string\",\"doc\":\"Booking center id\"},{\"name\":\"taxationId\",\"type\":\"string\",\"doc\":\"Taxation id\"},{\"name\":\"accounts\",\"type\":{\"type\":\"array\",\"items\":{\"type\":\"record\",\"name\":\"Account\",\"fields\":[{\"name\":\"actor\",\"type\":{\"type\":\"enum\",\"name\":\"Actor\",\"symbols\":[\"BUYER\",\"SELLER\"]},\"doc\":\"Actor for the account\"},{\"name\":\"accountId\",\"type\":\"string\",\"doc\":\"Account identifier\"},{\"name\":\"accountCurrency\",\"type\":\"string\",\"doc\":\"Account currency\"},{\"name\":\"accountType\",\"type\":\"string\",\"doc\":\"Account type : Cash account, custody account and block chain wallet\"},{\"name\":\"accountUsage\",\"type\":{\"type\":\"enum\",\"name\":\"AccountUsage\",\"symbols\":[\"CREDIT\",\"DEBIT\"]},\"doc\":\"Account usage in the transaction\"}]},\"java-type\":\"java.util.Set\"}}]}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }

  private static final SpecificData MODEL$ = new SpecificData();

  private static final BinaryMessageEncoder<Transaction> ENCODER =
      new BinaryMessageEncoder<>(MODEL$, SCHEMA$);

  private static final BinaryMessageDecoder<Transaction> DECODER =
      new BinaryMessageDecoder<>(MODEL$, SCHEMA$);

  /**
   * Return the BinaryMessageEncoder instance used by this class.
   * @return the message encoder used by this class
   */
  public static BinaryMessageEncoder<Transaction> getEncoder() {
    return ENCODER;
  }

  /**
   * Return the BinaryMessageDecoder instance used by this class.
   * @return the message decoder used by this class
   */
  public static BinaryMessageDecoder<Transaction> getDecoder() {
    return DECODER;
  }

  /**
   * Create a new BinaryMessageDecoder instance for this class that uses the specified {@link SchemaStore}.
   * @param resolver a {@link SchemaStore} used to find schemas by fingerprint
   * @return a BinaryMessageDecoder instance for this class backed by the given SchemaStore
   */
  public static BinaryMessageDecoder<Transaction> createDecoder(SchemaStore resolver) {
    return new BinaryMessageDecoder<>(MODEL$, SCHEMA$, resolver);
  }

  /**
   * Serializes this Transaction to a ByteBuffer.
   * @return a buffer holding the serialized data for this instance
   * @throws java.io.IOException if this instance could not be serialized
   */
  public java.nio.ByteBuffer toByteBuffer() throws java.io.IOException {
    return ENCODER.encode(this);
  }

  /**
   * Deserializes a Transaction from a ByteBuffer.
   * @param b a byte buffer holding serialized data for an instance of this class
   * @return a Transaction instance decoded from the given buffer
   * @throws java.io.IOException if the given bytes could not be deserialized into an instance of this class
   */
  public static Transaction fromByteBuffer(
      java.nio.ByteBuffer b) throws java.io.IOException {
    return DECODER.decode(b);
  }

  /** Transaction unique identifier */
  private java.lang.CharSequence id;
  /** Transaction message creation datetime */
  private long messageCreation;
  /** Transaction Price */
  private java.math.BigDecimal price;
  /** Transaction currency */
  private java.lang.CharSequence currency;
  /** Transaction quantity. Number of goods sold/bought */
  private int quantity;
  /** ISIN code that represent the good */
  private java.lang.CharSequence instrumentID;
  /** Datetime of the booking */
  private long bookingDateTime;
  /** Datetime of the settlement */
  private long settlementDateTime;
  /** Booking center id */
  private java.lang.CharSequence bookingCenterID;
  /** Taxation id */
  private java.lang.CharSequence taxationId;
  private java.util.List<com.marcofabbian.transaction.avroschema.Account> accounts;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use <code>newBuilder()</code>.
   */
  public Transaction() {}

  /**
   * All-args constructor.
   * @param id Transaction unique identifier
   * @param messageCreation Transaction message creation datetime
   * @param price Transaction Price
   * @param currency Transaction currency
   * @param quantity Transaction quantity. Number of goods sold/bought
   * @param instrumentID ISIN code that represent the good
   * @param bookingDateTime Datetime of the booking
   * @param settlementDateTime Datetime of the settlement
   * @param bookingCenterID Booking center id
   * @param taxationId Taxation id
   * @param accounts The new value for accounts
   */
  public Transaction(java.lang.CharSequence id, java.lang.Long messageCreation, java.math.BigDecimal price, java.lang.CharSequence currency, java.lang.Integer quantity, java.lang.CharSequence instrumentID, java.lang.Long bookingDateTime, java.lang.Long settlementDateTime, java.lang.CharSequence bookingCenterID, java.lang.CharSequence taxationId, java.util.List<com.marcofabbian.transaction.avroschema.Account> accounts) {
    this.id = id;
    this.messageCreation = messageCreation;
    this.price = price;
    this.currency = currency;
    this.quantity = quantity;
    this.instrumentID = instrumentID;
    this.bookingDateTime = bookingDateTime;
    this.settlementDateTime = settlementDateTime;
    this.bookingCenterID = bookingCenterID;
    this.taxationId = taxationId;
    this.accounts = accounts;
  }

  @Override
  public org.apache.avro.specific.SpecificData getSpecificData() { return MODEL$; }

  @Override
  public org.apache.avro.Schema getSchema() { return SCHEMA$; }

  // Used by DatumWriter.  Applications should not call.
  @Override
  public java.lang.Object get(int field$) {
    switch (field$) {
    case 0: return id;
    case 1: return messageCreation;
    case 2: return price;
    case 3: return currency;
    case 4: return quantity;
    case 5: return instrumentID;
    case 6: return bookingDateTime;
    case 7: return settlementDateTime;
    case 8: return bookingCenterID;
    case 9: return taxationId;
    case 10: return accounts;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  // Used by DatumReader.  Applications should not call.
  @Override
  @SuppressWarnings(value="unchecked")
  public void put(int field$, java.lang.Object value$) {
    switch (field$) {
    case 0: id = (java.lang.CharSequence)value$; break;
    case 1: messageCreation = (java.lang.Long)value$; break;
    case 2: price = (java.math.BigDecimal)value$; break;
    case 3: currency = (java.lang.CharSequence)value$; break;
    case 4: quantity = (java.lang.Integer)value$; break;
    case 5: instrumentID = (java.lang.CharSequence)value$; break;
    case 6: bookingDateTime = (java.lang.Long)value$; break;
    case 7: settlementDateTime = (java.lang.Long)value$; break;
    case 8: bookingCenterID = (java.lang.CharSequence)value$; break;
    case 9: taxationId = (java.lang.CharSequence)value$; break;
    case 10: accounts = (java.util.List<com.marcofabbian.transaction.avroschema.Account>)value$; break;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  /**
   * Gets the value of the 'id' field.
   * @return Transaction unique identifier
   */
  public java.lang.CharSequence getId() {
    return id;
  }


  /**
   * Sets the value of the 'id' field.
   * Transaction unique identifier
   * @param value the value to set.
   */
  public void setId(java.lang.CharSequence value) {
    this.id = value;
  }

  /**
   * Gets the value of the 'messageCreation' field.
   * @return Transaction message creation datetime
   */
  public long getMessageCreation() {
    return messageCreation;
  }


  /**
   * Sets the value of the 'messageCreation' field.
   * Transaction message creation datetime
   * @param value the value to set.
   */
  public void setMessageCreation(long value) {
    this.messageCreation = value;
  }

  /**
   * Gets the value of the 'price' field.
   * @return Transaction Price
   */
  public java.math.BigDecimal getPrice() {
    return price;
  }


  /**
   * Sets the value of the 'price' field.
   * Transaction Price
   * @param value the value to set.
   */
  public void setPrice(java.math.BigDecimal value) {
    this.price = value;
  }

  /**
   * Gets the value of the 'currency' field.
   * @return Transaction currency
   */
  public java.lang.CharSequence getCurrency() {
    return currency;
  }


  /**
   * Sets the value of the 'currency' field.
   * Transaction currency
   * @param value the value to set.
   */
  public void setCurrency(java.lang.CharSequence value) {
    this.currency = value;
  }

  /**
   * Gets the value of the 'quantity' field.
   * @return Transaction quantity. Number of goods sold/bought
   */
  public int getQuantity() {
    return quantity;
  }


  /**
   * Sets the value of the 'quantity' field.
   * Transaction quantity. Number of goods sold/bought
   * @param value the value to set.
   */
  public void setQuantity(int value) {
    this.quantity = value;
  }

  /**
   * Gets the value of the 'instrumentID' field.
   * @return ISIN code that represent the good
   */
  public java.lang.CharSequence getInstrumentID() {
    return instrumentID;
  }


  /**
   * Sets the value of the 'instrumentID' field.
   * ISIN code that represent the good
   * @param value the value to set.
   */
  public void setInstrumentID(java.lang.CharSequence value) {
    this.instrumentID = value;
  }

  /**
   * Gets the value of the 'bookingDateTime' field.
   * @return Datetime of the booking
   */
  public long getBookingDateTime() {
    return bookingDateTime;
  }


  /**
   * Sets the value of the 'bookingDateTime' field.
   * Datetime of the booking
   * @param value the value to set.
   */
  public void setBookingDateTime(long value) {
    this.bookingDateTime = value;
  }

  /**
   * Gets the value of the 'settlementDateTime' field.
   * @return Datetime of the settlement
   */
  public long getSettlementDateTime() {
    return settlementDateTime;
  }


  /**
   * Sets the value of the 'settlementDateTime' field.
   * Datetime of the settlement
   * @param value the value to set.
   */
  public void setSettlementDateTime(long value) {
    this.settlementDateTime = value;
  }

  /**
   * Gets the value of the 'bookingCenterID' field.
   * @return Booking center id
   */
  public java.lang.CharSequence getBookingCenterID() {
    return bookingCenterID;
  }


  /**
   * Sets the value of the 'bookingCenterID' field.
   * Booking center id
   * @param value the value to set.
   */
  public void setBookingCenterID(java.lang.CharSequence value) {
    this.bookingCenterID = value;
  }

  /**
   * Gets the value of the 'taxationId' field.
   * @return Taxation id
   */
  public java.lang.CharSequence getTaxationId() {
    return taxationId;
  }


  /**
   * Sets the value of the 'taxationId' field.
   * Taxation id
   * @param value the value to set.
   */
  public void setTaxationId(java.lang.CharSequence value) {
    this.taxationId = value;
  }

  /**
   * Gets the value of the 'accounts' field.
   * @return The value of the 'accounts' field.
   */
  public java.util.List<com.marcofabbian.transaction.avroschema.Account> getAccounts() {
    return accounts;
  }


  /**
   * Sets the value of the 'accounts' field.
   * @param value the value to set.
   */
  public void setAccounts(java.util.List<com.marcofabbian.transaction.avroschema.Account> value) {
    this.accounts = value;
  }

  /**
   * Creates a new Transaction RecordBuilder.
   * @return A new Transaction RecordBuilder
   */
  public static com.marcofabbian.transaction.avroschema.Transaction.Builder newBuilder() {
    return new com.marcofabbian.transaction.avroschema.Transaction.Builder();
  }

  /**
   * Creates a new Transaction RecordBuilder by copying an existing Builder.
   * @param other The existing builder to copy.
   * @return A new Transaction RecordBuilder
   */
  public static com.marcofabbian.transaction.avroschema.Transaction.Builder newBuilder(com.marcofabbian.transaction.avroschema.Transaction.Builder other) {
    if (other == null) {
      return new com.marcofabbian.transaction.avroschema.Transaction.Builder();
    } else {
      return new com.marcofabbian.transaction.avroschema.Transaction.Builder(other);
    }
  }

  /**
   * Creates a new Transaction RecordBuilder by copying an existing Transaction instance.
   * @param other The existing instance to copy.
   * @return A new Transaction RecordBuilder
   */
  public static com.marcofabbian.transaction.avroschema.Transaction.Builder newBuilder(com.marcofabbian.transaction.avroschema.Transaction other) {
    if (other == null) {
      return new com.marcofabbian.transaction.avroschema.Transaction.Builder();
    } else {
      return new com.marcofabbian.transaction.avroschema.Transaction.Builder(other);
    }
  }

  /**
   * RecordBuilder for Transaction instances.
   */
  @org.apache.avro.specific.AvroGenerated
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<Transaction>
    implements org.apache.avro.data.RecordBuilder<Transaction> {

    /** Transaction unique identifier */
    private java.lang.CharSequence id;
    /** Transaction message creation datetime */
    private long messageCreation;
    /** Transaction Price */
    private java.math.BigDecimal price;
    /** Transaction currency */
    private java.lang.CharSequence currency;
    /** Transaction quantity. Number of goods sold/bought */
    private int quantity;
    /** ISIN code that represent the good */
    private java.lang.CharSequence instrumentID;
    /** Datetime of the booking */
    private long bookingDateTime;
    /** Datetime of the settlement */
    private long settlementDateTime;
    /** Booking center id */
    private java.lang.CharSequence bookingCenterID;
    /** Taxation id */
    private java.lang.CharSequence taxationId;
    private java.util.List<com.marcofabbian.transaction.avroschema.Account> accounts;

    /** Creates a new Builder */
    private Builder() {
      super(SCHEMA$, MODEL$);
    }

    /**
     * Creates a Builder by copying an existing Builder.
     * @param other The existing Builder to copy.
     */
    private Builder(com.marcofabbian.transaction.avroschema.Transaction.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.id)) {
        this.id = data().deepCopy(fields()[0].schema(), other.id);
        fieldSetFlags()[0] = other.fieldSetFlags()[0];
      }
      if (isValidValue(fields()[1], other.messageCreation)) {
        this.messageCreation = data().deepCopy(fields()[1].schema(), other.messageCreation);
        fieldSetFlags()[1] = other.fieldSetFlags()[1];
      }
      if (isValidValue(fields()[2], other.price)) {
        this.price = data().deepCopy(fields()[2].schema(), other.price);
        fieldSetFlags()[2] = other.fieldSetFlags()[2];
      }
      if (isValidValue(fields()[3], other.currency)) {
        this.currency = data().deepCopy(fields()[3].schema(), other.currency);
        fieldSetFlags()[3] = other.fieldSetFlags()[3];
      }
      if (isValidValue(fields()[4], other.quantity)) {
        this.quantity = data().deepCopy(fields()[4].schema(), other.quantity);
        fieldSetFlags()[4] = other.fieldSetFlags()[4];
      }
      if (isValidValue(fields()[5], other.instrumentID)) {
        this.instrumentID = data().deepCopy(fields()[5].schema(), other.instrumentID);
        fieldSetFlags()[5] = other.fieldSetFlags()[5];
      }
      if (isValidValue(fields()[6], other.bookingDateTime)) {
        this.bookingDateTime = data().deepCopy(fields()[6].schema(), other.bookingDateTime);
        fieldSetFlags()[6] = other.fieldSetFlags()[6];
      }
      if (isValidValue(fields()[7], other.settlementDateTime)) {
        this.settlementDateTime = data().deepCopy(fields()[7].schema(), other.settlementDateTime);
        fieldSetFlags()[7] = other.fieldSetFlags()[7];
      }
      if (isValidValue(fields()[8], other.bookingCenterID)) {
        this.bookingCenterID = data().deepCopy(fields()[8].schema(), other.bookingCenterID);
        fieldSetFlags()[8] = other.fieldSetFlags()[8];
      }
      if (isValidValue(fields()[9], other.taxationId)) {
        this.taxationId = data().deepCopy(fields()[9].schema(), other.taxationId);
        fieldSetFlags()[9] = other.fieldSetFlags()[9];
      }
      if (isValidValue(fields()[10], other.accounts)) {
        this.accounts = data().deepCopy(fields()[10].schema(), other.accounts);
        fieldSetFlags()[10] = other.fieldSetFlags()[10];
      }
    }

    /**
     * Creates a Builder by copying an existing Transaction instance
     * @param other The existing instance to copy.
     */
    private Builder(com.marcofabbian.transaction.avroschema.Transaction other) {
      super(SCHEMA$, MODEL$);
      if (isValidValue(fields()[0], other.id)) {
        this.id = data().deepCopy(fields()[0].schema(), other.id);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.messageCreation)) {
        this.messageCreation = data().deepCopy(fields()[1].schema(), other.messageCreation);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.price)) {
        this.price = data().deepCopy(fields()[2].schema(), other.price);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.currency)) {
        this.currency = data().deepCopy(fields()[3].schema(), other.currency);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.quantity)) {
        this.quantity = data().deepCopy(fields()[4].schema(), other.quantity);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.instrumentID)) {
        this.instrumentID = data().deepCopy(fields()[5].schema(), other.instrumentID);
        fieldSetFlags()[5] = true;
      }
      if (isValidValue(fields()[6], other.bookingDateTime)) {
        this.bookingDateTime = data().deepCopy(fields()[6].schema(), other.bookingDateTime);
        fieldSetFlags()[6] = true;
      }
      if (isValidValue(fields()[7], other.settlementDateTime)) {
        this.settlementDateTime = data().deepCopy(fields()[7].schema(), other.settlementDateTime);
        fieldSetFlags()[7] = true;
      }
      if (isValidValue(fields()[8], other.bookingCenterID)) {
        this.bookingCenterID = data().deepCopy(fields()[8].schema(), other.bookingCenterID);
        fieldSetFlags()[8] = true;
      }
      if (isValidValue(fields()[9], other.taxationId)) {
        this.taxationId = data().deepCopy(fields()[9].schema(), other.taxationId);
        fieldSetFlags()[9] = true;
      }
      if (isValidValue(fields()[10], other.accounts)) {
        this.accounts = data().deepCopy(fields()[10].schema(), other.accounts);
        fieldSetFlags()[10] = true;
      }
    }

    /**
      * Gets the value of the 'id' field.
      * Transaction unique identifier
      * @return The value.
      */
    public java.lang.CharSequence getId() {
      return id;
    }


    /**
      * Sets the value of the 'id' field.
      * Transaction unique identifier
      * @param value The value of 'id'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder setId(java.lang.CharSequence value) {
      validate(fields()[0], value);
      this.id = value;
      fieldSetFlags()[0] = true;
      return this;
    }

    /**
      * Checks whether the 'id' field has been set.
      * Transaction unique identifier
      * @return True if the 'id' field has been set, false otherwise.
      */
    public boolean hasId() {
      return fieldSetFlags()[0];
    }


    /**
      * Clears the value of the 'id' field.
      * Transaction unique identifier
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder clearId() {
      id = null;
      fieldSetFlags()[0] = false;
      return this;
    }

    /**
      * Gets the value of the 'messageCreation' field.
      * Transaction message creation datetime
      * @return The value.
      */
    public long getMessageCreation() {
      return messageCreation;
    }


    /**
      * Sets the value of the 'messageCreation' field.
      * Transaction message creation datetime
      * @param value The value of 'messageCreation'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder setMessageCreation(long value) {
      validate(fields()[1], value);
      this.messageCreation = value;
      fieldSetFlags()[1] = true;
      return this;
    }

    /**
      * Checks whether the 'messageCreation' field has been set.
      * Transaction message creation datetime
      * @return True if the 'messageCreation' field has been set, false otherwise.
      */
    public boolean hasMessageCreation() {
      return fieldSetFlags()[1];
    }


    /**
      * Clears the value of the 'messageCreation' field.
      * Transaction message creation datetime
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder clearMessageCreation() {
      fieldSetFlags()[1] = false;
      return this;
    }

    /**
      * Gets the value of the 'price' field.
      * Transaction Price
      * @return The value.
      */
    public java.math.BigDecimal getPrice() {
      return price;
    }


    /**
      * Sets the value of the 'price' field.
      * Transaction Price
      * @param value The value of 'price'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder setPrice(java.math.BigDecimal value) {
      validate(fields()[2], value);
      this.price = value;
      fieldSetFlags()[2] = true;
      return this;
    }

    /**
      * Checks whether the 'price' field has been set.
      * Transaction Price
      * @return True if the 'price' field has been set, false otherwise.
      */
    public boolean hasPrice() {
      return fieldSetFlags()[2];
    }


    /**
      * Clears the value of the 'price' field.
      * Transaction Price
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder clearPrice() {
      price = null;
      fieldSetFlags()[2] = false;
      return this;
    }

    /**
      * Gets the value of the 'currency' field.
      * Transaction currency
      * @return The value.
      */
    public java.lang.CharSequence getCurrency() {
      return currency;
    }


    /**
      * Sets the value of the 'currency' field.
      * Transaction currency
      * @param value The value of 'currency'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder setCurrency(java.lang.CharSequence value) {
      validate(fields()[3], value);
      this.currency = value;
      fieldSetFlags()[3] = true;
      return this;
    }

    /**
      * Checks whether the 'currency' field has been set.
      * Transaction currency
      * @return True if the 'currency' field has been set, false otherwise.
      */
    public boolean hasCurrency() {
      return fieldSetFlags()[3];
    }


    /**
      * Clears the value of the 'currency' field.
      * Transaction currency
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder clearCurrency() {
      currency = null;
      fieldSetFlags()[3] = false;
      return this;
    }

    /**
      * Gets the value of the 'quantity' field.
      * Transaction quantity. Number of goods sold/bought
      * @return The value.
      */
    public int getQuantity() {
      return quantity;
    }


    /**
      * Sets the value of the 'quantity' field.
      * Transaction quantity. Number of goods sold/bought
      * @param value The value of 'quantity'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder setQuantity(int value) {
      validate(fields()[4], value);
      this.quantity = value;
      fieldSetFlags()[4] = true;
      return this;
    }

    /**
      * Checks whether the 'quantity' field has been set.
      * Transaction quantity. Number of goods sold/bought
      * @return True if the 'quantity' field has been set, false otherwise.
      */
    public boolean hasQuantity() {
      return fieldSetFlags()[4];
    }


    /**
      * Clears the value of the 'quantity' field.
      * Transaction quantity. Number of goods sold/bought
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder clearQuantity() {
      fieldSetFlags()[4] = false;
      return this;
    }

    /**
      * Gets the value of the 'instrumentID' field.
      * ISIN code that represent the good
      * @return The value.
      */
    public java.lang.CharSequence getInstrumentID() {
      return instrumentID;
    }


    /**
      * Sets the value of the 'instrumentID' field.
      * ISIN code that represent the good
      * @param value The value of 'instrumentID'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder setInstrumentID(java.lang.CharSequence value) {
      validate(fields()[5], value);
      this.instrumentID = value;
      fieldSetFlags()[5] = true;
      return this;
    }

    /**
      * Checks whether the 'instrumentID' field has been set.
      * ISIN code that represent the good
      * @return True if the 'instrumentID' field has been set, false otherwise.
      */
    public boolean hasInstrumentID() {
      return fieldSetFlags()[5];
    }


    /**
      * Clears the value of the 'instrumentID' field.
      * ISIN code that represent the good
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder clearInstrumentID() {
      instrumentID = null;
      fieldSetFlags()[5] = false;
      return this;
    }

    /**
      * Gets the value of the 'bookingDateTime' field.
      * Datetime of the booking
      * @return The value.
      */
    public long getBookingDateTime() {
      return bookingDateTime;
    }


    /**
      * Sets the value of the 'bookingDateTime' field.
      * Datetime of the booking
      * @param value The value of 'bookingDateTime'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder setBookingDateTime(long value) {
      validate(fields()[6], value);
      this.bookingDateTime = value;
      fieldSetFlags()[6] = true;
      return this;
    }

    /**
      * Checks whether the 'bookingDateTime' field has been set.
      * Datetime of the booking
      * @return True if the 'bookingDateTime' field has been set, false otherwise.
      */
    public boolean hasBookingDateTime() {
      return fieldSetFlags()[6];
    }


    /**
      * Clears the value of the 'bookingDateTime' field.
      * Datetime of the booking
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder clearBookingDateTime() {
      fieldSetFlags()[6] = false;
      return this;
    }

    /**
      * Gets the value of the 'settlementDateTime' field.
      * Datetime of the settlement
      * @return The value.
      */
    public long getSettlementDateTime() {
      return settlementDateTime;
    }


    /**
      * Sets the value of the 'settlementDateTime' field.
      * Datetime of the settlement
      * @param value The value of 'settlementDateTime'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder setSettlementDateTime(long value) {
      validate(fields()[7], value);
      this.settlementDateTime = value;
      fieldSetFlags()[7] = true;
      return this;
    }

    /**
      * Checks whether the 'settlementDateTime' field has been set.
      * Datetime of the settlement
      * @return True if the 'settlementDateTime' field has been set, false otherwise.
      */
    public boolean hasSettlementDateTime() {
      return fieldSetFlags()[7];
    }


    /**
      * Clears the value of the 'settlementDateTime' field.
      * Datetime of the settlement
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder clearSettlementDateTime() {
      fieldSetFlags()[7] = false;
      return this;
    }

    /**
      * Gets the value of the 'bookingCenterID' field.
      * Booking center id
      * @return The value.
      */
    public java.lang.CharSequence getBookingCenterID() {
      return bookingCenterID;
    }


    /**
      * Sets the value of the 'bookingCenterID' field.
      * Booking center id
      * @param value The value of 'bookingCenterID'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder setBookingCenterID(java.lang.CharSequence value) {
      validate(fields()[8], value);
      this.bookingCenterID = value;
      fieldSetFlags()[8] = true;
      return this;
    }

    /**
      * Checks whether the 'bookingCenterID' field has been set.
      * Booking center id
      * @return True if the 'bookingCenterID' field has been set, false otherwise.
      */
    public boolean hasBookingCenterID() {
      return fieldSetFlags()[8];
    }


    /**
      * Clears the value of the 'bookingCenterID' field.
      * Booking center id
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder clearBookingCenterID() {
      bookingCenterID = null;
      fieldSetFlags()[8] = false;
      return this;
    }

    /**
      * Gets the value of the 'taxationId' field.
      * Taxation id
      * @return The value.
      */
    public java.lang.CharSequence getTaxationId() {
      return taxationId;
    }


    /**
      * Sets the value of the 'taxationId' field.
      * Taxation id
      * @param value The value of 'taxationId'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder setTaxationId(java.lang.CharSequence value) {
      validate(fields()[9], value);
      this.taxationId = value;
      fieldSetFlags()[9] = true;
      return this;
    }

    /**
      * Checks whether the 'taxationId' field has been set.
      * Taxation id
      * @return True if the 'taxationId' field has been set, false otherwise.
      */
    public boolean hasTaxationId() {
      return fieldSetFlags()[9];
    }


    /**
      * Clears the value of the 'taxationId' field.
      * Taxation id
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder clearTaxationId() {
      taxationId = null;
      fieldSetFlags()[9] = false;
      return this;
    }

    /**
      * Gets the value of the 'accounts' field.
      * @return The value.
      */
    public java.util.List<com.marcofabbian.transaction.avroschema.Account> getAccounts() {
      return accounts;
    }


    /**
      * Sets the value of the 'accounts' field.
      * @param value The value of 'accounts'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder setAccounts(java.util.List<com.marcofabbian.transaction.avroschema.Account> value) {
      validate(fields()[10], value);
      this.accounts = value;
      fieldSetFlags()[10] = true;
      return this;
    }

    /**
      * Checks whether the 'accounts' field has been set.
      * @return True if the 'accounts' field has been set, false otherwise.
      */
    public boolean hasAccounts() {
      return fieldSetFlags()[10];
    }


    /**
      * Clears the value of the 'accounts' field.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Transaction.Builder clearAccounts() {
      accounts = null;
      fieldSetFlags()[10] = false;
      return this;
    }

    @Override
    @SuppressWarnings("unchecked")
    public Transaction build() {
      try {
        Transaction record = new Transaction();
        record.id = fieldSetFlags()[0] ? this.id : (java.lang.CharSequence) defaultValue(fields()[0]);
        record.messageCreation = fieldSetFlags()[1] ? this.messageCreation : (java.lang.Long) defaultValue(fields()[1]);
        record.price = fieldSetFlags()[2] ? this.price : (java.math.BigDecimal) defaultValue(fields()[2]);
        record.currency = fieldSetFlags()[3] ? this.currency : (java.lang.CharSequence) defaultValue(fields()[3]);
        record.quantity = fieldSetFlags()[4] ? this.quantity : (java.lang.Integer) defaultValue(fields()[4]);
        record.instrumentID = fieldSetFlags()[5] ? this.instrumentID : (java.lang.CharSequence) defaultValue(fields()[5]);
        record.bookingDateTime = fieldSetFlags()[6] ? this.bookingDateTime : (java.lang.Long) defaultValue(fields()[6]);
        record.settlementDateTime = fieldSetFlags()[7] ? this.settlementDateTime : (java.lang.Long) defaultValue(fields()[7]);
        record.bookingCenterID = fieldSetFlags()[8] ? this.bookingCenterID : (java.lang.CharSequence) defaultValue(fields()[8]);
        record.taxationId = fieldSetFlags()[9] ? this.taxationId : (java.lang.CharSequence) defaultValue(fields()[9]);
        record.accounts = fieldSetFlags()[10] ? this.accounts : (java.util.List<com.marcofabbian.transaction.avroschema.Account>) defaultValue(fields()[10]);
        return record;
      } catch (org.apache.avro.AvroMissingFieldException e) {
        throw e;
      } catch (java.lang.Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumWriter<Transaction>
    WRITER$ = (org.apache.avro.io.DatumWriter<Transaction>)MODEL$.createDatumWriter(SCHEMA$);

  @Override public void writeExternal(java.io.ObjectOutput out)
    throws java.io.IOException {
    WRITER$.write(this, SpecificData.getEncoder(out));
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumReader<Transaction>
    READER$ = (org.apache.avro.io.DatumReader<Transaction>)MODEL$.createDatumReader(SCHEMA$);

  @Override public void readExternal(java.io.ObjectInput in)
    throws java.io.IOException {
    READER$.read(this, SpecificData.getDecoder(in));
  }

  @Override protected boolean hasCustomCoders() { return true; }

  @Override public void customEncode(org.apache.avro.io.Encoder out)
    throws java.io.IOException
  {
    out.writeString(this.id);

    out.writeLong(this.messageCreation);

    out.writeString(this.price.toString());

    out.writeString(this.currency);

    out.writeInt(this.quantity);

    out.writeString(this.instrumentID);

    out.writeLong(this.bookingDateTime);

    out.writeLong(this.settlementDateTime);

    out.writeString(this.bookingCenterID);

    out.writeString(this.taxationId);

    long size0 = this.accounts.size();
    out.writeArrayStart();
    out.setItemCount(size0);
    long actualSize0 = 0;
    for (com.marcofabbian.transaction.avroschema.Account e0: this.accounts) {
      actualSize0++;
      out.startItem();
      e0.customEncode(out);
    }
    out.writeArrayEnd();
    if (actualSize0 != size0)
      throw new java.util.ConcurrentModificationException("Array-size written was " + size0 + ", but element count was " + actualSize0 + ".");

  }

  @Override public void customDecode(org.apache.avro.io.ResolvingDecoder in)
    throws java.io.IOException
  {
    org.apache.avro.Schema.Field[] fieldOrder = in.readFieldOrderIfDiff();
    if (fieldOrder == null) {
      this.id = in.readString(this.id instanceof Utf8 ? (Utf8)this.id : null);

      this.messageCreation = in.readLong();

      this.price = new java.math.BigDecimal(in.readString());

      this.currency = in.readString(this.currency instanceof Utf8 ? (Utf8)this.currency : null);

      this.quantity = in.readInt();

      this.instrumentID = in.readString(this.instrumentID instanceof Utf8 ? (Utf8)this.instrumentID : null);

      this.bookingDateTime = in.readLong();

      this.settlementDateTime = in.readLong();

      this.bookingCenterID = in.readString(this.bookingCenterID instanceof Utf8 ? (Utf8)this.bookingCenterID : null);

      this.taxationId = in.readString(this.taxationId instanceof Utf8 ? (Utf8)this.taxationId : null);

      long size0 = in.readArrayStart();
      java.util.List<com.marcofabbian.transaction.avroschema.Account> a0 = this.accounts;
      if (a0 == null) {
        a0 = new SpecificData.Array<com.marcofabbian.transaction.avroschema.Account>((int)size0, SCHEMA$.getField("accounts").schema());
        this.accounts = a0;
      } else a0.clear();
      SpecificData.Array<com.marcofabbian.transaction.avroschema.Account> ga0 = (a0 instanceof SpecificData.Array ? (SpecificData.Array<com.marcofabbian.transaction.avroschema.Account>)a0 : null);
      for ( ; 0 < size0; size0 = in.arrayNext()) {
        for ( ; size0 != 0; size0--) {
          com.marcofabbian.transaction.avroschema.Account e0 = (ga0 != null ? ga0.peek() : null);
          if (e0 == null) {
            e0 = new com.marcofabbian.transaction.avroschema.Account();
          }
          e0.customDecode(in);
          a0.add(e0);
        }
      }

    } else {
      for (int i = 0; i < 11; i++) {
        switch (fieldOrder[i].pos()) {
        case 0:
          this.id = in.readString(this.id instanceof Utf8 ? (Utf8)this.id : null);
          break;

        case 1:
          this.messageCreation = in.readLong();
          break;

        case 2:
          this.price = new java.math.BigDecimal(in.readString());
          break;

        case 3:
          this.currency = in.readString(this.currency instanceof Utf8 ? (Utf8)this.currency : null);
          break;

        case 4:
          this.quantity = in.readInt();
          break;

        case 5:
          this.instrumentID = in.readString(this.instrumentID instanceof Utf8 ? (Utf8)this.instrumentID : null);
          break;

        case 6:
          this.bookingDateTime = in.readLong();
          break;

        case 7:
          this.settlementDateTime = in.readLong();
          break;

        case 8:
          this.bookingCenterID = in.readString(this.bookingCenterID instanceof Utf8 ? (Utf8)this.bookingCenterID : null);
          break;

        case 9:
          this.taxationId = in.readString(this.taxationId instanceof Utf8 ? (Utf8)this.taxationId : null);
          break;

        case 10:
          long size0 = in.readArrayStart();
          java.util.List<com.marcofabbian.transaction.avroschema.Account> a0 = this.accounts;
          if (a0 == null) {
            a0 = new SpecificData.Array<com.marcofabbian.transaction.avroschema.Account>((int)size0, SCHEMA$.getField("accounts").schema());
            this.accounts = a0;
          } else a0.clear();
          SpecificData.Array<com.marcofabbian.transaction.avroschema.Account> ga0 = (a0 instanceof SpecificData.Array ? (SpecificData.Array<com.marcofabbian.transaction.avroschema.Account>)a0 : null);
          for ( ; 0 < size0; size0 = in.arrayNext()) {
            for ( ; size0 != 0; size0--) {
              com.marcofabbian.transaction.avroschema.Account e0 = (ga0 != null ? ga0.peek() : null);
              if (e0 == null) {
                e0 = new com.marcofabbian.transaction.avroschema.Account();
              }
              e0.customDecode(in);
              a0.add(e0);
            }
          }
          break;

        default:
          throw new java.io.IOException("Corrupt ResolvingDecoder.");
        }
      }
    }
  }
}










